Package io.vertx.reactivex.ext.auth.oauth2.providers

## Class GoogleAuth

- java.lang.Object
- - io.vertx.reactivex.ext.auth.oauth2.providers.OpenIDConnectAuth
  - - io.vertx.reactivex.ext.auth.oauth2.providers.GoogleAuth

-     public class GoogleAuth
      extends OpenIDConnectAuth

  Simplified factory to create an `OAuth2Auth` for Google.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<GoogleAuth>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GoogleAuth​(GoogleAuth delegate)` |
    `GoogleAuth​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static OAuth2Auth` | `create​(Vertx vertx, JsonObject serviceAccountJson)` | Create a OAuth2Auth provider for Google Service Account (Server to Server)
    `static OAuth2Auth` | `create​(Vertx vertx, JsonObject serviceAccountJson, HttpClientOptions httpClientOptions)` | Create a OAuth2Auth provider for Google Service Account (Server to Server)
    `static OAuth2Auth` | `create​(Vertx vertx, String clientId, String clientSecret)` | Create a OAuth2Auth provider for Google
    `static OAuth2Auth` | `create​(Vertx vertx, String clientId, String clientSecret, HttpClientOptions httpClientOptions)` | Create a OAuth2Auth provider for Google
    `static Future<OAuth2Auth>` | `discover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.
    `boolean` | `equals​(Object o)` |
    `GoogleAuth` | `getDelegate()` |
    `int` | `hashCode()` |
    `static GoogleAuth` | `newInstance​(GoogleAuth arg)` |
    `static Single<OAuth2Auth>` | `rxDiscover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.
    `String` | `toString()` |

    - ### Methods inherited from class io.vertx.reactivex.ext.auth.oauth2.providers.OpenIDConnectAuth

      `newInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<GoogleAuth> __TYPE_ARG

  - ### Constructor Detail

    - #### GoogleAuth

          public GoogleAuth​(GoogleAuth delegate)

    - #### GoogleAuth

          public GoogleAuth​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `OpenIDConnectAuth`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `OpenIDConnectAuth`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `OpenIDConnectAuth`

    - #### getDelegate

          public GoogleAuth getDelegate()

      Overrides:
        `getDelegate` in class `OpenIDConnectAuth`

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          String clientId,
                                          String clientSecret)

      Create a OAuth2Auth provider for Google
      Parameters:
        `vertx` -
        `clientId` - the client id given to you by Google
        `clientSecret` - the client secret given to you by Google
      Returns:

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          String clientId,
                                          String clientSecret,
                                          HttpClientOptions httpClientOptions)

      Create a OAuth2Auth provider for Google
      Parameters:
        `vertx` -
        `clientId` - the client id given to you by Google
        `clientSecret` - the client secret given to you by Google
        `httpClientOptions` - custom http client options
      Returns:

    - #### discover

          public static Future<OAuth2Auth> discover​(Vertx vertx,
                                                    OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with the instantiated Oauth2 provider instance handler

    - #### rxDiscover

          public static Single<OAuth2Auth> rxDiscover​(Vertx vertx,
                                                      OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with the instantiated Oauth2 provider instance handler

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          JsonObject serviceAccountJson)

      Create a OAuth2Auth provider for Google Service Account (Server to Server)
      Parameters:
        `vertx` -
        `serviceAccountJson` - the configuration json file from your Google API page
      Returns:

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          JsonObject serviceAccountJson,
                                          HttpClientOptions httpClientOptions)

      Create a OAuth2Auth provider for Google Service Account (Server to Server)
      Parameters:
        `vertx` -
        `serviceAccountJson` - the configuration json file from your Google API page
        `httpClientOptions` - custom http client options
      Returns:

    - #### newInstance

          public static GoogleAuth newInstance​(GoogleAuth arg)